/**
 * @file libce.c
 *
 * stdio.h ̊ȈՔŁB
 * IWi iruka B肪Ƃ܂B
 *
 * @author Komatsudaira Yoshiki
 * @version $Id: libce.c 12 2006-11-10 14:58:02Z komatsu $
 */

/**********************************************************************
 *
 *		stdio.c ̂悤Ȃ́iShift-JIŜ݃T|[gj
 *
 *		S̓IɎ蔲ł.
 **********************************************************************
 */
//#define __NO_STDIO_INLINE__

/**
 * _CRTIMP ĂȂƁȀŃRpCG[ɂȂB
 *  - RpC wce500 p clarm g
 *  - wcsxxx() g
 * Ȃł͂킩B
 */
#define	_CRTIMP

#include <stdlib.h>
#include "../debuglog.h"
#include "tinyio.h"

#define	MAX_FILES	16

#define	DEBUG_LIBCE	0

//#define	NMULTITHREAD


#define	TTY_FD	(-2)
int	errprintf(char *fmt,... );
/**********************************************************************
 *		
 **********************************************************************
typedef struct	{
	int     	flags;		// tOrbg          	       
	int 		fd;			// WinCẼt@Cnh         

	unsigned char *buffer;	// Xg[Eobt@            
	unsigned char *curp;	// [̓ǂݏ|C^    
	unsigned char *eofp;	// [̓ǂݍݎ|C^̍ŏIʒu 
	unsigned char *endp;	// [̏ݎ|C^̍ŏIʒu 
	int 		bsize;		// Xg[Eobt@̊mۃTCY         
	int			level;		// Xg[Eobt@̎gpoCg       

	char  		token;		// FILE\̂gpȂ...1      
	char  		istty;		// TTY INȂ1 OUTȂ2 t@C=0 
	char		hold;		// ungetc()pz[hobt@      
}	FILE;
 *
 *	FILE̊Ǘ@:
 *		fopen() buffer[bsize]mۂ.(malloc)
 *		curp = eofp = endp = buffer ɂĂ.
 *
 *		getc()̓}NŎ.	curp < eofp ̏ꍇ getc = (*curp++);
 *		curp  eofp ɒBAfgetc_fillbuf(fp)ĂяoāAobt@
 *		ɗ߂. ܂obt@̏I[ʒu eofp ɃZbg.
 *
 *		putc()}NŎ.   curp < endp ̏ꍇ (*curp++)=c;
 *		curp  endp ɒBAfflush(fp)ĂяoāAobt@o.
 *
 *		fseek()Ƃ́Afflush(fp)sāA჌xseeksȂA
 *		curp = eofp = endp = buffer ɂĂ.
 *
 *		getc()putc()݂Ƃ́AԂfflush()Afseek()܂
 *		Γ͕ۏ؂ȂB
 *
 *	_IOLBF   eofp = endp = buffer ƂāAfputc()ɗ悤ɂ
 *	fputc() *curp++ = c;sB curp  buffer + bsize -1 ɓB
 *	A'\n'ꂽ̂݁AR\[ɓfoB
 *
 *	_IONBF ̓T|[gȂB
 *
 *		s\risjŁAGetch()𔭍sꍇ͖Ifflush()
 *		KvƂȂ.
 *
 *
 */

FILE _streams[MAX_FILES];	// [0] stdin ,[1] stdout ,[2] stderr


/**********************************************************************
 *		󂢂Ă _streams[] T.
 **********************************************************************
 */
static FILE *new_streams(void)
{
	int i;
	FILE *f;
	for(i=3;i<MAX_FILES;i++) {
		f = &_streams[i];
		if(f->token==0) return f;
	}
	return NULL;
}

/**********************************************************************
 *		
 **********************************************************************
 */
static void *xmalloc(int size)
{
	void *p;
	p = malloc(size);
	if(p==NULL) {
		errprintf("Memory exhaust!\n");
//		exit(1);
	}
	return p;
}
/**********************************************************************
 *		_stream \̂ttyo͗pɏ.
 **********************************************************************
 */
static void set_stream(FILE *f,int flag)
{
	f->token  = 1;
	f->istty  = flag;
	f->level  = 0;
	f->fd     = TTY_FD;
	f->bsize  = BUFSIZ;
	f->buffer = xmalloc( f->bsize );
	f->curp   = f->buffer;
	f->endp   = f->buffer;
	f->eofp   = f->buffer;
	f->flags  = flag;
}

static void chk_fp(FILE *f)
{
	unsigned int fd = f - _streams;
	if(fd >= MAX_FILES) {
//		errprintf("celib.c: Internal Error . *fp = %x\n",f);exit(1);
	}
}

/**********************************************************************
 *		_streams[] ̏.
 **********************************************************************
 */
void celib_init(void)
{
	int i;
	FILE *f;

	for(i=0;i<MAX_FILES;i++) {
		f = &_streams[i];
		f->token  = 0;
		f->istty  = 0;
		f->flags  = 0;
		f->level  = 0;

		f->bsize  = 0;
		f->buffer = NULL;
		f->curp   = NULL;
		f->endp   = NULL;
		f->eofp   = NULL;

#ifndef NMULTITHREAD
		InitializeCriticalSection(&f->cs);
		InitializeCriticalSection(&f->cs_fwrite);
#endif
	}

	set_stream(stdin ,_IOREAD |_IOLBF);
	set_stream(stdout,_IOWRITE|_IOLBF);
	set_stream(stderr,_IOWRITE|_IOLBF);

}

/**********************************************************************
 *		
 **********************************************************************
 */
int sjis2TCHAR( char *src, TCHAR *dst, int max )
{
	return MultiByteToWideChar( CP_ACP, 0, src, -1, dst, max )<<1 ;
}

/**********************************************************************
 *		蔲 printf()n.
 **********************************************************************
 */

int	libce_vsprintf(char *buf, const char *fmt, va_list arglist);

int	errprintf(char *fmt,... )
{
	char  buf[1024];
	TCHAR Tbuf[1024];
	va_list	 va_ptr;
	int ret;

	va_start( va_ptr, fmt ) ;
		ret = vsprintf(buf,fmt,va_ptr);
		sjis2TCHAR( buf,Tbuf,1020 );
//		Cputs( Tbuf );
	va_end( va_ptr );
	return ret;
}

/**********************************************************************
 *		r-ihrp:Pڔ.
 **********************************************************************
 */
static int iskanji1(int c)
{
	if ((c>=0x81)&&(c<0xa0)) return 1;
	if ((c>=0xe0)&&(c<0xfc)) return 1;
	return 0;
}

#if	0
/**********************************************************************
 *		r-ihrp:o.
 **********************************************************************
 */
static void conout(int c,FILE *f)
{
	char  buf[32];
	TCHAR Tbuf[32];

	c &= 0xff;
	if(	f->hold ) {	//S-JISQڂ̏.
		buf[0]=f->hold;
		buf[1]=c;
		buf[2]=0;

		sjis2TCHAR( buf,Tbuf,16 );
		Cputs( Tbuf );
		f->hold = 0;
	}else{
		if(iskanji1(c)) {	//S-JIS Pڂ̏.
			f->hold = c;
		}else{
			Tbuf[0]=c;
			Tbuf[1]=0;
			Cputs( Tbuf );
		}
	}
}
#endif
/**********************************************************************
 *		}NA`
 **********************************************************************
 */
static	char	*vp;
static	void vputc(int c)
{
	*vp++ = c;
}

static int is_num(int c)
{
	if ( (c < '0') || (c > '9') ) {
		return -1;
	}
	return c - '0';
}

/**********************************************************************
 *		oB
 **********************************************************************
 */
static const char *getnum(const char *s, int *val)
{
	int v,r,sgn;
	char c;
	v = 0;
	sgn = 1;

	*val = 0;
	c = *s;
	if (c == '-') {
		s++;
		c = *s;
		sgn = -1;
	}

	if (is_num(c) >= 0) {
		while ( (r = is_num(*s)) >=0) {
			v *= 10;
			v += r;
			s++;
		}
		*val = v * sgn;
	}
	return s;
}

/**********************************************************************
 *		Tu[`
 **********************************************************************
 */
static	int hexch(int c,int alp)
{
	if(c>=10)	 c += alp;	/* 'A''a'  */
				 c += '0';
	return(c);
}

static void hexprint(long val, int column, int fmt, int filler)
{
	char hexbuf[32];
	int radix;
	int i;
	int alp = 0;
	int minus = 0;
	unsigned long v;

	switch (fmt) {
	  case 'x' :
	  case 'X' :
		alp = fmt == 'x' ? 0x27 : 0x07;
		radix = 16;
		v = (unsigned long)val;
		break;
	  case 'd' :
		radix = 10;
		v = val < 0 ? -val : val;
		minus = v < 0;
		break;
	  case 'u' :
		radix = 10;
		v = val;
		break;
	}

	i = 0;
	do {
		hexbuf[i++] = hexch((unsigned)v %  radix, alp);
		(unsigned) v /= radix;
	} while (v != 0);

	if (minus && filler == '0') {
		vputc('-');
		while (column > (i+1)) {
			vputc(filler);
			column--;
		}
	} else {
		if (minus) {
			hexbuf[i++]='-';
		}
		while (column>i) {
			vputc(filler);
			column--;
		}
	}

	while(i > 0) {
		vputc(hexbuf[--i]);
	}
}

static	void strprint(char *s,int column)
{
	int	l;
	int slen;
	slen=strlen(s);

	/* ]KvȂ */
	if(   column > slen ) {
		l=column - slen;
		while(l) {
			vputc(' ');l--;
		}
	}

	while(*s) {
		vputc(*s++);
	}

	/* E]KvȂ */
	if( column<0 ) {
	if(   (-column) > slen ) {
		l=(-column) - slen;
		while(l) {
			vputc(' ');l--;
		}
	}
	}
}

static void wstrprint(wchar_t *s, int column)
{
	int	l;
	int slen;
	char c[4];		/* 4 ͂ȂƂȂ... */

	slen = wcslen(s);

	/* ]KvȂ */
	if (column > slen) {
		l = column - slen;
		while (l) {
			vputc(' ');
			l--;
		}
	}

	while(*s) {
//		wctomb(c, *s++);
		c[0] = (*s++) & 0xff;
		vputc(c[0]);
	}

	/* E]KvȂ */
	if (column < 0) {
		if ((-column) > slen) {
			l = (-column) - slen;
			while (l) {
				vputc(' ');
				l--;
			}
		}
	}
}

static	void chrprint(int c)
{
	vputc(c);
}

/**********************************************************************
 *		ij
 **********************************************************************
 */
int	vsprintf(char *buf , const char *fmt , va_list ap)
{
	int  column;
	int  c, filler;
	int long_f;

	vp = buf;

	while (*fmt) {
		if (*fmt == '%') {					/* GXP[v */
			column=1;
			if(fmt[1]=='0') filler='0';
			else		    filler=' ';

			fmt = getnum(fmt+1, &column);	/* ̌̐ => column */

			c = *fmt++;
			long_f = 0;
			if (c == 'l') {
				long_f = 1;
				c = *fmt++;
			}
			switch(c) {
			  case 'd' :
			  case 'D' :
			  case 'u' :
				if (long_f) {
					hexprint(va_arg(ap, long), column, c, filler);
				} else {
					hexprint(va_arg(ap, int),  column, c, filler);
				}
				break;
			  case 'x':
			  case 'X':
				if (long_f) {
					hexprint(va_arg(ap, long), column, c, filler);
				} else {
					hexprint(va_arg(ap, int),  column, c, filler);
				}
				break;
			  case 's':
				strprint(  va_arg (ap, char *),column);					break;
			  case 'S' :
				wstrprint( va_arg (ap, wchar_t*), column);				break;
			  case 'c':
				chrprint(  va_arg (ap, int) );							break;
#if	0
			  case 'f':
			  case 'F':
			  case 'g':
			  case 'G':
				dblprint( ap,c );
#endif
			  case '%':
				chrprint( '%' );			   break;
			  default:
				break;
			}
		} else {
//			if(*fmt == '\n') 
//				vputc( '\r');	/* lr-cnr̎dl(CR+LF)Ɉ˂ */
			vputc(*fmt++);
		}
	}
	vputc(0);
	/* EVC ̃wvpB
	 * Return Value
	 * sprintf returns the number of bytes stored in buffer, not counting
	 * the terminating null character.
	 * swprintf returns the number of wide characters stored in buffer,
	 * not counting the terminating null wide character.
	 */
	/* vp  static char *vpB
	 * vputc() sƈiށB
	 * ɗƂɂ \0 o͍ς݂ŁAvp ܂ŐiłB
	 */
	return ((vp - 1) - buf);
}

/**********************************************************************
 *		
 **********************************************************************
 */
int libce_printf(char *format, ...)
{
	char _prbuf[1024];
	int i,l;
    va_list ap;

    va_start (ap, format);
	i = vsprintf(_prbuf,format,ap);
    va_end (ap);
    
	l=strlen(_prbuf);
	fwrite(_prbuf,1,l,stdout);
	return i;
}
/**********************************************************************
 *		
 **********************************************************************
 */
#if	0	// Ȃ񂩂ub{{Ă܂IȂ("%s\n",s)݂Ȉ
		// X^bNt[Ɏc炸ɃWX^ɏ܂܂łB
		// ǁAprintf͂ƓĂ̂ŁAub{{̋C܂ꂩ???.
int libce_fprintf(FILE *fp, char *format, int arg1 , int arg2 , ...)
{
	char _prbuf[1024];	//݂܂蔲ł.
	int i,l;
    va_list ap;

	i = (int) &arg1;	//AhXQƂ鎖ŖWX^A[h.
	l = (int) &arg2;

    va_start (ap, format);
	i = vsprintf(_prbuf,format,ap);
    va_end (ap);

	l=strlen(_prbuf);
	fwrite(_prbuf,1,l,fp);
	return i;
}
#else

//͂ub{{oOĂȂΐƎv镁ʂ̏.
int	 fprintf(FILE *fp, char *format, ...)
{
	char _prbuf[1024];
	int i,l;
    va_list ap;

    va_start (ap, format);
	i = vsprintf(_prbuf,format,ap);
    va_end (ap);

	l=strlen(_prbuf);
	fwrite(_prbuf,1,l,fp);
	return i;
}
#endif
/**********************************************************************
 *		
 **********************************************************************
 */
static char *convpath(char *t,const char *s)
{
	char *r = t;
	while(*s) {
		if(*s =='/' ) *t++ = '\\';
		else *t++ = *s;
		
		s++;
	}
	*t=0;
	return r;
}
/**********************************************************************
 *		
 **********************************************************************
 */
static FILE *fopen_r(const char *filename, char *mode, FILE *f)
{
	DBGLBL("fopen_r")
	int createf=OPEN_EXISTING;
	int writef =GENERIC_READ;
	int flags  =0;
	char name[256];
	TCHAR abuf[256];
	HANDLE hFile;

	DBGLOGLN(("filename='%s', mode='%s', f=0x%08x.", filename, mode, f));

	switch( mode[0] ) {
	  case 'r':
		flags = _IOREAD;
		writef  = GENERIC_READ;
		createf = OPEN_EXISTING;
		break;
	 case 'w':
		flags = _IOWRITE;
		writef  = GENERIC_WRITE;
		createf = CREATE_ALWAYS;
		break;
	 case 'a':
		flags = _IOWRITE;
		writef  = GENERIC_WRITE;
		createf = OPEN_ALWAYS;
		break;
	  default:
		return NULL;
	}
	switch( mode[1]) {
	  case '+' :
		flags |= _IOUPD;
		writef = GENERIC_READ | GENERIC_WRITE;
		break;
	  case 'b' :
		/* mode[1] Ⴕ傤Ȃ̂ */
		flags |= _IOBIN;
		break;
	  default:
		break;
	}

//	sjis2TCHAR( convpath(name,filename) ,tbuf,510 );
//	rel2absdir( abuf,256,tbuf );
	sjis2TCHAR( convpath(name,filename) ,abuf,510 );
	DBGLOGLN(("abuf='%S', writef=0x%08x, createf=0x%04x.", abuf, writef, createf));

	hFile = CreateFile(abuf, writef, FILE_SHARE_READ, NULL, createf, FILE_ATTRIBUTE_NORMAL, 0);
	f->fd = (int)hFile;
	DBGLOGLN(("fd=0x%08x.", hFile));
	if (hFile == INVALID_HANDLE_VALUE) {
		return NULL ;
	}

	switch (mode[0]) {
	  case 'w' :
		SetEndOfFile(hFile);
		break;
	  case 'a' :
		SetFilePointer(hFile, 0, NULL, FILE_END);
		break;
	}

	f->token = 1;
	f->flags = flags;
	f->istty = 0;
	f->level = 0;

	f->bsize  = BUFSIZ;
	f->buffer = xmalloc( f->bsize );
	f->curp   = f->buffer;
	f->endp   = f->buffer;
	f->eofp   = f->buffer;

	return f;
}

/**********************************************************************
 *		
 **********************************************************************
 */
FILE *libce_freopen(char *filename, char *mode, FILE *fp)
{
	return fopen_r(filename, mode, fp);
}

/**********************************************************************
 *		
 **********************************************************************
 */
FILE *libce_fopen(const char *filename, char *mode)
{
	FILE *fp;
	fp = new_streams();
	if (!fp) {
		return NULL;
	}
	return fopen_r(filename, mode, fp);
}
/**********************************************************************
 *		
 **********************************************************************
 */
FILE *set_redirect(FILE *fp,char *filename,char *mode)
{
	return fopen_r(filename, mode, fp);
}
/**********************************************************************
 *		
 **********************************************************************
 */
char *libce_fgets(char *buf, int n, FILE *fp)
{
	int  c;
	char *s=buf;

	if (--n < 0) {
		return NULL;
	}

	while (--n >= 0 && (c = getc(fp)) != '\n') {
		/* ̂?? */
		if (c == 0x0d) {
			continue;
		}
		if (c == EOF) {
			if (s == buf) {
				return NULL;
			} else {
				break;
			}
		}
		*s++ = c;
	}
	if (c == '\n') {
		*s++ = c;
	}
	*s = 0;
	return buf;
}
/**********************************************************************
 *		
 **********************************************************************
 */
int libce_sprintf(char *buffer, char *format, ...)
{
	int ret;
	va_list va_ptr;

	va_start(va_ptr, format);
	ret = vsprintf(buffer, format, va_ptr);
	va_end(va_ptr);
	return ret;
}

/**********************************************************************
 *		
 **********************************************************************
 */
int libce_puts(char *s)
{
	while(*s) putchar(*s++);
	putchar('\n');
	return  '\n';
}

/**********************************************************************
 *		
 **********************************************************************
 */
int libce_fwrite(void *ptr, unsigned size, unsigned n, FILE *fp)
{
	unsigned int len;
	char *s = ptr;

	len = size * n;
#ifndef NMULTITHREAD
	EnterCriticalSection(&fp->cs_fwrite);
#endif
	while(len != 0) {
		putc(*s,fp);s++;len--;
	}
#ifndef NMULTITHREAD
	LeaveCriticalSection(&fp->cs_fwrite);
#endif
	return size * n;
}
/**********************************************************************
 *		
 **********************************************************************
 */
int libce_fread(void *ptr, unsigned size, unsigned n, FILE *fp)
{
	unsigned int len0, len;
	int c;
	char *s = ptr;

	len = len0 = size * n;
	do {
		c = getc(fp);
		if (c == EOF) {
			break;
		}
		*s++ = c;
	} while (--len);
	return (len0 - len) / size;		/* ǂ item ̌ */
}
/**********************************************************************
 *		
 **********************************************************************
 */
#define	C_(n) ((n)-0x40)

int	 libce_fflush(FILE *f)
{
	DBGLBL("libce_fflush")
	DWORD donesize=0;

	if (f->buffer) {
		DBGLOGLN(("flags=0x%04x, level=%d.", f->flags, f->level));
	}

	if( f->flags & _IOWRITE ) {
		if ( (f->flags & _IOBMASK) == _IOFBF )  {
			if(f->buffer!= f->endp) {		//obt@Of[^?
				f->level = f->curp - f->buffer;	//ݗĂoCg.
				if(f->level) {
					WriteFile( (HANDLE)f->fd, f->buffer , f->level , &donesize , NULL ) ;
#if 1
					/* 20041215 komatsu */
					FlushFileBuffers((HANDLE)f->fd);
#endif
					if((int)donesize != f->level) return EOF;	// FAIL.
#if	DEBUG_LIBCE
					errprintf("fflush(%x) 2\n",f->flags);
#endif
#if 0
					/* ȉ̏́ACgł͂Ȃ[hKv */
					f->curp  = f->buffer;	//݃|C^߂.
					f->level = 0;
					f->endp  = f->buffer;
					f->eofp  = f->buffer;
#endif
				}
			}
		} else {
			/* _fputc_flsh()  copy&pasteB
			 * ȂƂׂ...B
			 */
#if 0
			TCHAR Tbuf[BUFSIZ];
			int brk;
			*f->curp = 0;
			sjis2TCHAR( f->buffer,Tbuf,BUFSIZ );
			Cputs( Tbuf );
			f->curp  = f->buffer;		//|C^߂.
			f->level = 0;
			//o͒ ^C  ^S ̎󂯕t.
			if( Kbhit() ) {
				brk = Getch();
				if(brk == C_('S')) {	// ^S󂯂AɂP҂.
					brk = Getch();
				}
				if(brk == C_('C')) exit(11);	// ^C Ȃ甲.
			}
#endif
		}
	}
	f->curp  = f->buffer;	//݃|C^߂.
	f->level = 0;
	f->endp  = f->buffer;
	f->eofp  = f->buffer;
	return 0;	// Success
}
/**********************************************************************
 *		
 **********************************************************************
 */
#if 0
/* ̂قɈړ */
#define	C_(n) ((n)-0x40)
#endif

int	 _fputc_flsh(char c, FILE *f)
{
//	int brk;
	int ret;

#ifndef NMULTITHREAD
	EnterCriticalSection(&f->cs);
#endif
	chk_fp(f);
	if ( !(f->flags & _IOWRITE) ) {
		c = EOF;
		goto L_EXIT;
	}

	if (f->buffer) {		//obt@O.
		if( (f->flags & _IOBMASK) == _IOFBF ) {
			if ( fflush(f) == EOF ) {
				ret = EOF;
				goto L_EXIT;
			}
			f->endp  = f->buffer + f->bsize;//Xg[obt@eʕ̃|C^݂.
			*f->curp++ = c;					//̕(c)P.
			ret = c;
			goto L_EXIT;

		} else {			//sobt@O.(R\[)
#if 0
			TCHAR Tbuf[BUFSIZ];

			ret = c;
			*f->curp++ = c; f->level++;		//Ɉ̕(c)P.
			if ( (c=='\n') || (f->curp >= (f->buffer + f->bsize - 1) ) ) {
				//sbobt@tɂȂ,
				*f->curp = 0;
				sjis2TCHAR( f->buffer,Tbuf,BUFSIZ );
				Cputs( Tbuf );
				f->curp  = f->buffer;		//|C^߂.
				f->level = 0;

#if	1	//o͒ ^C  ^S ̎󂯕t.
				if( Kbhit() ) {
					brk = Getch();
					if(brk == C_('S')) {	// ^S󂯂AɂP҂.
						brk = Getch();
					}
					if (brk == C_('C')) {
						// ^C Ȃ甲.
						exit(11);
					}
				}
#endif
			}
#endif
		}
	} else {				//obt@OȂ.(ڃR\[)
#if	0
		if(f->istty == 2) {
			conout(c,f);
			return c;
		}
#endif
		ret = EOF;
	}

  L_EXIT :
#ifndef NMULTITHREAD
	LeaveCriticalSection(&f->cs);
#endif
	return ret;
}
/**********************************************************************
 *		
 **********************************************************************
 */
int libce_fclose(FILE *f)
{
	DBGLBL("libce_fclose")

	if (f && f->token == 1 && (HANDLE)f->fd != INVALID_HANDLE_VALUE) {
		DBGLOGLN(("flags=0x%04x.", f->flags));
		fflush(f);
		CloseHandle( (HANDLE)f->fd );
		f->token = 0;
		if(f->buffer) {
			free(f->buffer);
			f->buffer = NULL;
		}
	} else {
		DBGLOGLN(("f=0x%08x, token=%d, fd=0x%08x.", f, f->token, f->fd));
	}
	return 0;
}

/**********************************************************************
 *		
 **********************************************************************
 */
int	 _fgetc_fill(FILE *f)
{
	DWORD donesize;
	BOOL  r;
	
	chk_fp(f);

	if(f->flags & _IOEOF) return EOF;
	if(!(f->flags & _IOREAD)) return EOF;

	fflush(f);
	if(f->buffer) {
		r = ReadFile( (HANDLE)f->fd, f->buffer , f->bsize , &donesize , NULL ) ;
		if( !r || (donesize==0) ) {
			f->flags |= _IOEOF;
			return EOF;
		}
		f->curp  = f->buffer;
		f->level = f->bsize;
		if( (int)donesize != f->bsize ) f->level = donesize;

		f->endp  = f->buffer;
		f->eofp  = f->buffer + f->level;

		return  *f->curp++;
	}else{
//		return Getch();		//Ή!
	}
	return EOF;
}

/**********************************************************************
 *		
 **********************************************************************
 */
int libce_fgetc(FILE *f)
{
#if	DEBUG_LIBCE
	chk_fp(f);
#endif

	if( f->curp < f->eofp ) {
		return *f->curp ++;
	}else{
		return _fgetc_fill(f);
	}
}
/**********************************************************************
 *		
 **********************************************************************
 */
int libce_fputc(char c,FILE *f)
{
#if	DEBUG_LIBCE
	chk_fp(f);
#endif

	if( f->curp < f->endp ) {
		*f->curp ++ = c;
		return c;
	}else{
		return _fputc_flsh(c,f);
	}
}

/**********************************************************************
 *		malloc[ɃRs[Ã|C^Ԃ
 **********************************************************************
 */
char *xstrdup(char *string)
{
    return (char *) strcpy(xmalloc (strlen (string) + 1), string);
}

static DWORD unicode2sjis( LPCTSTR src, BYTE *dst, DWORD max )
{
	return WideCharToMultiByte( CP_ACP, 0, src, -1, dst, dst ? max : 0, NULL, NULL ) ;
}

static char *u2a(TCHAR *src)
{
	static char u2abuf[256+1];
	unicode2sjis( src,u2abuf,256 );
	return u2abuf;
}

/**
 * Xg[ʒuݒ
 *
 * @param fp t@C|C^
 * @param offset t@Cʒu
 * @param whence ʒuw
 * @return 0:OK
 * @return -1:ERR
 */
int libce_fseek(FILE *fp, long offset, int whence)
{
    /* Xg[tbV */
	if (fflush (fp) < 0) {
		return -1;
	}

	if ((fp->flags & _IOBMASK) !=_IOFBF) {
		return -1;
	}

    /* ۂ seek  */
	if (SetFilePointer((HANDLE)fp->fd, offset, NULL, whence) == 0xFFFFFFFF) {
		return -1;
	}

    /* I[wqNA */
    fp->flags &= ~_IOEOF;

    /*  */
    return 0;
}

/**
 * Xg[ʒu擾
 * 
 * @param fp t@C|C^
 * @return t@Cʒu
 */
long libce_ftell(FILE *fp)
{
	return (long)SetFilePointer((HANDLE)fp->fd, 0, NULL, FILE_CURRENT);
}

/**
 * so
 *
 * @param s o͍s
 * @param fp t@C|C^
 * @return o͕
 */
int libce_fputs(char *s, FILE *fp)
{
	char c;
	int pre_cr;
	int cnt;

	cnt = 0;
	pre_cr = 0;
	while ( (c = *s++) != '\0' ) {
		switch (c) {
		  case 0x0d :
			pre_cr = 1;
			break;
		  case 0x0a :
			if (!pre_cr) {
				fputc(0x0d, fp);
				cnt++;
			}
			/* fall througn */
		  default :
			pre_cr = 0;
		}
		fputc(c, fp);
		cnt++;
	}
	return cnt;
}


#define	WCHAR_WORKBUF_LEN		(1024)

/**
 * to
 *
 * obt@̑傫Œł邱ƂɒӁB
 * m炸Ƀ󂷉\\ɂB
 *
 * @param fp t@C|C^
 * @param fmt 
 * @return 0 (W֐ƂĂ͕sł邱Ƃɒ)
 */
int libce_fwprintf(FILE *fp, WCHAR *fmt, ...)
{
	va_list ap;
	WCHAR *w;
	char *m;
	int n;

	w = LocalAlloc(LPTR, WCHAR_WORKBUF_LEN);
	if (w == NULL) {
		return -1;
	}
	m = LocalAlloc(LPTR, WCHAR_WORKBUF_LEN);
	if (m == NULL) {
		LocalFree(w);
		return -1;
	}

	va_start(ap, fmt);
	vswprintf(w, fmt, ap);
	va_end(ap);

	n = WideCharToMultiByte( CP_ACP,				/* UINT		CodePage			*/
							 0,						/* DWORD	dwFlags				*/
							 w,						/* LPCSTR	lpWideCharStr		*/
							 -1,					/* int		ccWideChar			*/
							 m,						/* LPSTR	lpMultiByteStr		*/
							 WCHAR_WORKBUF_LEN,		/* int		cbMultiByte			*/
							 NULL,					/* LPCSTR	lpDefaultChar		*/
							 NULL );				/* LPBOOL	lpUsedDefaultChar	*/

	/* n  '\0' ܂ޒ̂悤 */
//	fwrite(m, 1, n-1, fp);
	/* fputs() ŏo͂ 0x0a -> 0x0d, 0x0a ϊ\B
	 * ܂ӖȂǁAu stdiovŐt@C̉sR[h
	 * 0x0d, 0x0a Ȃ񂾂낤ȁB
	 */
	fputs(m, fp);

	LocalFree(m);
	LocalFree(w);

	return 0;
}

/**
 * s(WCHAR)
 *
 * ̓sB
 *   - fgets()  MBCS s͂
 *   - WCHAR ɕϊ
 *
 * MBCS œ͂obt@̑傫͓ŌŒɂȂĂB
 * fgets() ł̈s͂ƁAparam sz Ɋ֘AȂB
 * ̂߁A͂łȂƂB
 * 蔲ɂقǂB
 *
 * @param dst i[
 * @param sz i[TCY
 * @param fp
 * @return
 */
WCHAR *libce_fgetws(WCHAR *dst, size_t sz, FILE *fp)
{
	char *w;
	char *b;

	w = LocalAlloc(LPTR, WCHAR_WORKBUF_LEN);
	if (w == NULL) {
		return NULL;
	}

	b = libce_fgets(w, WCHAR_WORKBUF_LEN, fp);
	if (b == NULL) {
		goto L_EXIT;
	}
	MultiByteToWideChar( CP_ACP,			/* UINT		CodePage		*/
						 MB_PRECOMPOSED,	/* DWORD	dwFlags			*/
						 w,					/* LPCSTR	lpMultiByteStr	*/
						 -1,				/* int		cbMultiByte		*/
						 dst,				/* LPWSTR	lpWideCharStr	*/
						 sz );				/* int		cchWideChar		*/
	b = (char*)dst;
  L_EXIT :
	LocalFree(w);
	return (WCHAR*)b;
}
