/**
 * @file mbs_wcs.c
 *
 * mbstowcs(), wcstombs() bsO
 *  - wce2.11 ł͂̊֐Ӑ}Ȃ
 *  - MultiByteToWideChar(), WideCharToMultiByte() ͈Ӑ}
 *  - mbstowcs(), wcstombs() u
 *
 * @author komatsu
 * @version $Id: mbs_wcs.c 4 2006-11-09 12:57:33Z komatsu $
 */

#define	WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdlib.h>
#include "mbs_wcs.h"

/**
 * }`oCg񁨃ChLN^ϊ
 *
 * }`oCgChLN^ɕϊ܂B
 *
 * @param wcstr ϊ̕BNULL ł OK
 * @param mbstr ϊO̕
 * @param count ϊʂi[̈̑傫 (Ch̒PʂŎw)
 * @return ϊ
 */
size_t _mbstowcs(WCHAR *wcstr, const char *mbstr, size_t count)
{
	/* size_t mbstowcs( wchar_t *wcstr, const char *mbstr, size_t count );
	 *
	 * Parameters
	 *   wcstr		The address of a sequence of wide characters 
	 *   mbstr		The address of a sequence of multibyte characters 
	 *   count		The number of multibyte characters to convert
	 */

	return MultiByteToWideChar( CP_ACP,			/* UINT		CodePage		*/
								MB_PRECOMPOSED,	/* DWORD	dwFlags			*/
								mbstr,			/* LPCSTR	lpMultiByteStr	*/
								-1,				/* int		cbMultiByte		*/	/* lpMultiByteStr ̃TCYoCgPʂŎw	*/
								wcstr,			/* LPWSTR	lpWideCharStr	*/
								count );		/* int		cchWideChar		*/	/* Ch̒PʂŎw						*/
}

/**
 * ChLN^񁨃}`oCgϊ
 *
 * }`oCgChLN^ɕϊ܂B
 *
 * @param mbstr ϊ̃}`oCg
 * @param wcstr ϊÕChLN^
 * @param count ϊʂi[̈̑傫 (}`oCg̒PʂŎw)
 * @return ϊ
 */
size_t _wcstombs(char *mbstr, const WCHAR *wcstr, size_t count)
{
	return WideCharToMultiByte( CP_ACP,		/* UINT		CodePage			*/
								0,			/* DWORD	dwFlags				*/
								wcstr,		/* LPCSTR	lpWideCharStr		*/
								-1,			/* int		ccWideChar			*/
								mbstr,		/* LPSTR	lpMultiByteStr		*/
								count,		/* int		cbMultiByte			*/
								NULL,		/* LPCSTR	lpDefaultChar		*/
								NULL );		/* LPBOOL	lpUsedDefaultChar	*/
}
