#include	"stdafx.h"
#include	<stdlib.h>
#include	"surelist.h"



// mۂĕL
TCHAR *CSureInfo::NewStr( TCHAR *str )
{
	TCHAR *ret = new TCHAR[_tcslen(str)+1];
	if ( ret != NULL ){
		_tcscpy( ret , str );
	}
	return ret;
}


CSureInfo::CSureInfo(
	UINT iimage,
	TCHAR *title,
	int resnum,
	int lognum,
	TCHAR *dat,
	TCHAR *bbs,
	TCHAR *server,
	int itemnum )
{
	m_iimage = iimage;	// ACRԍ
	m_resnum = resnum;	// X
	m_lognum = lognum;	// O
	m_itemnum= itemnum;	// ACeԍ
	m_title  = NewStr( title );	// X^Cg
	m_dat    = NewStr( dat );		// dat
	m_bbs    = NewStr( bbs );		// BBS
	m_server = NewStr( server );	// T[o
}

CSureInfo::~CSureInfo(){
	DELA( m_title );
	DELA( m_bbs );
	DELA( m_dat );
	DELA( m_server );
}

// \[gpr֐
int		CSureInfo::Compare( CSureInfo *cmp1 ,CSureInfo *cmp2 ,int kind,bool up )
{
	int	ret = 0;

	// Pږڂō~̎̓ACȐŃ\[g(ǁOL聨O)
	if ( kind == 0 && !up ){
		kind = -1;
	}

	switch( kind ){
	case -1:	ret = cmp1->GetIimage() - cmp2->GetIimage();			break;
	case 0:		ret = 0;												break;
	case 1:		ret = _tcscmp( cmp1->GetTitle() , cmp2->GetTitle() );	break;
	case 2:		ret = cmp1->GetResnum() - cmp2->GetResnum();			break;
	case 3:		ret = cmp1->GetLognum() - cmp2->GetLognum();			break;
	case 4:		ret = _tcscmp( cmp1->GetDat() , cmp2->GetDat() );		break;
	case 5:		ret = _tcscmp( cmp1->GetBbs() , cmp2->GetBbs() );		break;
	case 6:		ret = _tcscmp( cmp1->GetServer() , cmp2->GetServer() );	break;
	case 7:		ret = cmp1->GetItemnum() - cmp2->GetItemnum();			break;
	default:	break;
	}
	// ~̎͌ʂt]
	if ( !up ){
		ret = -ret;
	}
	// rĈv烍ŐL^Ƃ
	if ( ret == 0 ){
		ret = cmp1->GetRegno() - cmp2->GetRegno();
	}
	return ret;
}

// staticϐ
int CSureList::m_sortkind;
bool CSureList::m_sortup;


CSureList::CSureList(int max){
	m_max = max;
	m_list = new CSureInfo*[max];
	m_surenum = 0;
}

CSureList::~CSureList(){
	for( int i=0;i<m_surenum;i++ ){
		DEL( m_list[i] );
	}
	DELA( m_list );
}

// Xgɒǉ
int	CSureList::Add( CSureInfo *sure ){
	if ( m_surenum<m_max-1 ){
		sure->SetRegno(m_surenum);		// o^L^
		m_list[m_surenum++] = sure;
	}
	return m_surenum;
}

// \[g
void CSureList::Sort( int kind , bool up )
{
	m_sortkind = kind;		// \[gڂۑ
	m_sortup = up;			// \[gۑ
	qsort( m_list , m_surenum , sizeof( m_list[0] ) , Compare );
}
// qsortpr֐
int CSureList::Compare(const void *p1, const void *p2)
{
	CSureInfo **s1 = (CSureInfo **)p1;
	CSureInfo **s2 = (CSureInfo **)p2;
	int cmp = CSureInfo::Compare( *s1 , *s2 , m_sortkind , m_sortup);
	return cmp;
}

