#pragma once


class CSureInfo {
private:
	UINT	m_regno;	// o^ԍ
	UINT	m_iimage;	// ACRԍ
	TCHAR*	m_title;	// X^Cg
	int		m_resnum;	// X
	int 	m_lognum;	// O
	TCHAR*	m_dat;		// dat
	TCHAR*	m_bbs;		// BBS
	TCHAR*	m_server;	// T[o
	int		m_itemnum;	// ACeԍ

	TCHAR *NewStr( TCHAR *str );

public:
	CSureInfo(
		UINT iimage,
		TCHAR *title,
		int resnum,
		int lognum,
		TCHAR *dat,
		TCHAR *bbs,
		TCHAR *server,
		int itemnum );
		
	virtual ~CSureInfo();

	inline	UINT	GetRegno()	{ return m_regno;	}
	inline	UINT	GetIimage()	{ return m_iimage;	}
	inline	TCHAR*	GetTitle()	{ return m_title;	}
	inline	int		GetResnum()	{ return m_resnum;	}
	inline	int 	GetLognum()	{ return m_lognum;	}
	inline	TCHAR*	GetDat()	{ return m_dat;		}
	inline	TCHAR*	GetBbs()	{ return m_bbs;		}
	inline	TCHAR*	GetServer()	{ return m_server;	}
	inline	int		GetItemnum(){ return m_itemnum;	}
	
	inline	void	SetIimage(UINT	val)	{  m_iimage = val;	}
	inline	void	SetRegno(UINT	val)	{  m_regno = val;	}

	static	int		Compare( CSureInfo *cmp1 ,CSureInfo *cmp2 ,int kind , bool up);
};


class CSureList {
private:
	CSureInfo 	**m_list;
	int			m_surenum;
	int			m_max;
	static	int m_sortkind;
	static	bool m_sortup;
public:
	CSureList(int max);
	virtual ~CSureList();
	int	Add( CSureInfo *sure );

	inline	int	GetCount(){return m_surenum;}				// Xg̍ڐ擾
	inline	CSureInfo *Get( int i ){return 	m_list[i];}		// ڎ擾

	void Sort( int kind , bool up );
	static	int Compare(const void *p1, const void *p2);
	int	FindRegno(int regno){
		int	i;
		for( i=0;i<m_surenum;i++){
			if ( m_list[i]->GetRegno() == regno ){
				return i;
			}
		}
		return -1;
	}
};



